#ifndef _EVAS_ECTOR_BUFFER_EO_H_
#define _EVAS_ECTOR_BUFFER_EO_H_

#ifndef _EVAS_ECTOR_BUFFER_EO_CLASS_TYPE
#define _EVAS_ECTOR_BUFFER_EO_CLASS_TYPE

typedef Eo Evas_Ector_Buffer;

#endif

#ifndef _EVAS_ECTOR_BUFFER_EO_TYPES
#define _EVAS_ECTOR_BUFFER_EO_TYPES


#endif
/** Evas ector buffer interface
 *
 * @ingroup Evas_Ector_Buffer
 */
#define EVAS_ECTOR_BUFFER_INTERFACE evas_ector_buffer_interface_get()

EWAPI const Efl_Class *evas_ector_buffer_interface_get(void);

/**
 * @brief Engine image property
 *
 * This Buffer will hold a reference to the evas image struct.
 *
 * @param[in] evas The current Evas.
 * @param[in] image The engine-specific image struct.
 *
 * @ingroup Evas_Ector_Buffer
 */
EOAPI void evas_ector_buffer_engine_image_set(Eo *obj, Evas_Canvas *evas, void *image);

/**
 * @brief Engine image property
 *
 * @param[out] evas The current Evas.
 * @param[out] image The engine-specific image struct.
 *
 * @ingroup Evas_Ector_Buffer
 */
EOAPI void evas_ector_buffer_engine_image_get(const Eo *obj, Evas_Canvas **evas, void **image);

#endif
